package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLMultiUnionPWAff_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLMultiUnionPWAff extends JNIObject implements IISLStandardMethods {
	
	/* @generated */
	protected ISLMultiUnionPWAff(long ptr) {
		/*** PROTECTED REGION ID(ISLMultiUnionPWAff_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLMultiUnionPWAff build(long ptr) {
		return new ISLMultiUnionPWAff(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLMultiUnionPWAff_userCode) ENABLED START ***/
	public String toString(ISL_FORMAT format) {
		return ISLPrettyPrinter.asString(this, format);
	}
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * isl_multi_union_pw_aff_read_from_str 
	 * 
	 * @generated
	**/
	 public static ISLMultiUnionPWAff buildFromString(ISLContext ctx, String str) { 
		/*** PROTECTED REGION ID(static_isl_multi_union_pw_aff_read_from_str) DISABLED START ***/
		ISLMultiUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLMultiUnionPWAff.build(ISLNative.isl_multi_union_pw_aff_read_from_str(getNativePtr(ctx), str));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_zero 
	 * 
	@take space
	 * @generated
	**/
	 public static ISLMultiUnionPWAff buildZero(ISLSpace space) { 
		/*** PROTECTED REGION ID(static_isl_multi_union_pw_aff_zero) DISABLED START ***/
		ISLMultiUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(space);
			try {
				res = ISLMultiUnionPWAff.build(ISLNative.isl_multi_union_pw_aff_zero(getNativePtr(space)));
			} finally {
				taken(space);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_multi_val_on_domain 
	 * 
	@take domain mv
	 * @generated
	**/
	 public static ISLMultiUnionPWAff buildMultiValOnDomain(ISLUnionSet domain, ISLMultiVal mv) { 
		/*** PROTECTED REGION ID(static_isl_multi_union_pw_aff_multi_val_on_domain) DISABLED START ***/
		ISLMultiUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(domain, mv);
			try {
				res = ISLMultiUnionPWAff.build(ISLNative.isl_multi_union_pw_aff_multi_val_on_domain(getNativePtr(domain), getNativePtr(mv)));
			} finally {
				taken(domain);
				taken(mv);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_multi_aff_on_domain 
	 * 
	@take domain ma
	 * @generated
	**/
	 public static ISLMultiUnionPWAff buildMultiAffOnDomain(ISLUnionSet domain, ISLMultiAff ma) { 
		/*** PROTECTED REGION ID(static_isl_multi_union_pw_aff_multi_aff_on_domain) DISABLED START ***/
		ISLMultiUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(domain, ma);
			try {
				res = ISLMultiUnionPWAff.build(ISLNative.isl_multi_union_pw_aff_multi_aff_on_domain(getNativePtr(domain), getNativePtr(ma)));
			} finally {
				taken(domain);
				taken(ma);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_pw_multi_aff_on_domain 
	 * 
	@take domain pma
	 * @generated
	**/
	 public static ISLMultiUnionPWAff buildPWMultiAffOnDomain(ISLUnionSet domain, ISLPWMultiAff pma) { 
		/*** PROTECTED REGION ID(static_isl_multi_union_pw_aff_pw_multi_aff_on_domain) DISABLED START ***/
		ISLMultiUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(domain, pma);
			try {
				res = ISLMultiUnionPWAff.build(ISLNative.isl_multi_union_pw_aff_pw_multi_aff_on_domain(getNativePtr(domain), getNativePtr(pma)));
			} finally {
				taken(domain);
				taken(pma);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_from_union_pw_aff_list 
	 * 
	@take space list
	 * @generated
	**/
	 public static ISLMultiUnionPWAff buildFromUnionPWAffList(ISLSpace space, ISLUnionPWAffList list) { 
		/*** PROTECTED REGION ID(static_isl_multi_union_pw_aff_from_union_pw_aff_list) DISABLED START ***/
		ISLMultiUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(space, list);
			try {
				res = ISLMultiUnionPWAff.build(ISLNative.isl_multi_union_pw_aff_from_union_pw_aff_list(getNativePtr(space), getNativePtr(list)));
			} finally {
				taken(space);
				taken(list);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_from_range 
	 * 
	@take mupa
	 * @generated
	**/
	 public static ISLMultiUnionPWAff buildFromRange(ISLMultiUnionPWAff mupa) { 
		/*** PROTECTED REGION ID(static_isl_multi_union_pw_aff_from_range) DISABLED START ***/
		ISLMultiUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(mupa);
			try {
				res = ISLMultiUnionPWAff.build(ISLNative.isl_multi_union_pw_aff_from_range(getNativePtr(mupa)));
			} finally {
				taken(mupa);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_to_string 
	 * 
	 * @generated
	**/
	 public static String _toString(ISLMultiUnionPWAff mupa, int format) { 
		/*** PROTECTED REGION ID(static_isl_multi_union_pw_aff_to_string) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_multi_union_pw_aff_to_string(getNativePtr(mupa), format);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_multi_union_pw_aff_get_ctx 
	 * 
	 * @generated
	**/
	public ISLContext getContext() {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_get_ctx) DISABLED START ***/
		ISLContext res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLContext.build(ISLNative.isl_multi_union_pw_aff_get_ctx(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_get_space 
	 * 
	 * @generated
	**/
	public ISLSpace getSpace() {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_get_space) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLSpace.build(ISLNative.isl_multi_union_pw_aff_get_space(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_copy 
	 * 
	 * @generated
	**/
	public ISLMultiUnionPWAff copy() {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_copy) DISABLED START ***/
		ISLMultiUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLMultiUnionPWAff.build(ISLNative.isl_multi_union_pw_aff_copy(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_multi_union_pw_aff_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_dim 
	 * 
	 * @generated
	**/
	public int dim(ISLDimType type) {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_dim) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_multi_union_pw_aff_dim(getNativePtr(this), type.getValue());
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_get_union_pw_aff 
	 * 
	 * @generated
	**/
	public ISLUnionPWAff getUnionPWAff(int pos) {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_get_union_pw_aff) DISABLED START ***/
		ISLUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLUnionPWAff.build(ISLNative.isl_multi_union_pw_aff_get_union_pw_aff(getNativePtr(this), pos));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_set_union_pw_aff 
	 * 
	 * @take this upa
	 * @generated
	**/
	public ISLMultiUnionPWAff setUnionPWAff(int pos, ISLUnionPWAff upa) {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_set_union_pw_aff) DISABLED START ***/
		ISLMultiUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, upa);
			try {
				res = ISLMultiUnionPWAff.build(ISLNative.isl_multi_union_pw_aff_set_union_pw_aff(getNativePtr(this), pos, getNativePtr(upa)));
			} finally {
				taken(this);
				taken(upa);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_extract_multi_pw_aff 
	 * 
	 * @take space
	 * @generated
	**/
	public ISLMultiPWAff extractMultiPWAff(ISLSpace space) {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_extract_multi_pw_aff) DISABLED START ***/
		ISLMultiPWAff res;
		
		synchronized(LOCK) {
			checkParameters(space);
			try {
				res = ISLMultiPWAff.build(ISLNative.isl_multi_union_pw_aff_extract_multi_pw_aff(getNativePtr(this), getNativePtr(space)));
			} finally {
				taken(space);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_set_dim_id 
	 * 
	 * @take this id
	 * @generated
	**/
	public ISLMultiUnionPWAff setDimID(ISLDimType type, int pos, ISLIdentifier id) {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_set_dim_id) DISABLED START ***/
		ISLMultiUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, id);
			try {
				res = ISLMultiUnionPWAff.build(ISLNative.isl_multi_union_pw_aff_set_dim_id(getNativePtr(this), type.getValue(), pos, getNativePtr(id)));
			} finally {
				taken(this);
				taken(id);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_get_dim_id 
	 * 
	 * @generated
	**/
	public ISLIdentifier getDimID(ISLDimType type, int pos) {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_get_dim_id) DISABLED START ***/
		ISLIdentifier res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLIdentifier.build(ISLNative.isl_multi_union_pw_aff_get_dim_id(getNativePtr(this), type.getValue(), pos));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_set_dim_name 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMultiUnionPWAff setDimName(ISLDimType type, int pos, String s) {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_set_dim_name) DISABLED START ***/
		ISLMultiUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMultiUnionPWAff.build(ISLNative.isl_multi_union_pw_aff_set_dim_name(getNativePtr(this), type.getValue(), pos, s));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_find_dim_by_id 
	 * 
	 * @generated
	**/
	public int findDimByID(ISLDimType type, ISLIdentifier id) {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_find_dim_by_id) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_multi_union_pw_aff_find_dim_by_id(getNativePtr(this), type.getValue(), getNativePtr(id));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_find_dim_by_name 
	 * 
	 * @generated
	**/
	public int findDimByName(ISLDimType type, String name) {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_find_dim_by_name) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_multi_union_pw_aff_find_dim_by_name(getNativePtr(this), type.getValue(), name);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_set_tuple_id 
	 * 
	 * @take this id
	 * @generated
	**/
	public ISLMultiUnionPWAff setTupleID(ISLDimType type, ISLIdentifier id) {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_set_tuple_id) DISABLED START ***/
		ISLMultiUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, id);
			try {
				res = ISLMultiUnionPWAff.build(ISLNative.isl_multi_union_pw_aff_set_tuple_id(getNativePtr(this), type.getValue(), getNativePtr(id)));
			} finally {
				taken(this);
				taken(id);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_reset_tuple_id 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMultiUnionPWAff resetTupleID(ISLDimType type) {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_reset_tuple_id) DISABLED START ***/
		ISLMultiUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMultiUnionPWAff.build(ISLNative.isl_multi_union_pw_aff_reset_tuple_id(getNativePtr(this), type.getValue()));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_has_tuple_id 
	 * 
	 * @generated
	**/
	public boolean hasTupleID(ISLDimType type) {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_has_tuple_id) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_multi_union_pw_aff_has_tuple_id(getNativePtr(this), type.getValue()) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_get_tuple_id 
	 * 
	 * @generated
	**/
	public ISLIdentifier getTupleID(ISLDimType type) {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_get_tuple_id) DISABLED START ***/
		ISLIdentifier res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLIdentifier.build(ISLNative.isl_multi_union_pw_aff_get_tuple_id(getNativePtr(this), type.getValue()));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_set_tuple_name 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMultiUnionPWAff setTupleName(ISLDimType type, String s) {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_set_tuple_name) DISABLED START ***/
		ISLMultiUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMultiUnionPWAff.build(ISLNative.isl_multi_union_pw_aff_set_tuple_name(getNativePtr(this), type.getValue(), s));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_get_tuple_name 
	 * 
	 * @generated
	**/
	public String getTupleName(ISLDimType type) {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_get_tuple_name) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_multi_union_pw_aff_get_tuple_name(getNativePtr(this), type.getValue());
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_reset_user 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMultiUnionPWAff resetUser() {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_reset_user) DISABLED START ***/
		ISLMultiUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMultiUnionPWAff.build(ISLNative.isl_multi_union_pw_aff_reset_user(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_range_is_wrapping 
	 * 
	 * @generated
	**/
	public boolean isRangeWrapping() {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_range_is_wrapping) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_multi_union_pw_aff_range_is_wrapping(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_involves_nan 
	 * 
	 * @generated
	**/
	public boolean involvesNaN() {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_involves_nan) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_multi_union_pw_aff_involves_nan(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_plain_is_equal 
	 * 
	 * @generated
	**/
	public boolean isPlainEqual(ISLMultiUnionPWAff mupa2) {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_plain_is_equal) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_multi_union_pw_aff_plain_is_equal(getNativePtr(this), getNativePtr(mupa2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_domain 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionSet domain() {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_domain) DISABLED START ***/
		ISLUnionSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionSet.build(ISLNative.isl_multi_union_pw_aff_domain(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_zero_union_set 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionSet zeroUnionSet() {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_zero_union_set) DISABLED START ***/
		ISLUnionSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionSet.build(ISLNative.isl_multi_union_pw_aff_zero_union_set(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_coalesce 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMultiUnionPWAff coalesce() {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_coalesce) DISABLED START ***/
		ISLMultiUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMultiUnionPWAff.build(ISLNative.isl_multi_union_pw_aff_coalesce(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_min_multi_val 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMultiVal min() {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_min_multi_val) DISABLED START ***/
		ISLMultiVal res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMultiVal.build(ISLNative.isl_multi_union_pw_aff_min_multi_val(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_max_multi_val 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMultiVal max() {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_max_multi_val) DISABLED START ***/
		ISLMultiVal res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMultiVal.build(ISLNative.isl_multi_union_pw_aff_max_multi_val(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_flatten_range 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMultiUnionPWAff flattenRange() {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_flatten_range) DISABLED START ***/
		ISLMultiUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMultiUnionPWAff.build(ISLNative.isl_multi_union_pw_aff_flatten_range(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_align_params 
	 * 
	 * @take this model
	 * @generated
	**/
	public ISLMultiUnionPWAff alignParams(ISLSpace model) {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_align_params) DISABLED START ***/
		ISLMultiUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, model);
			try {
				res = ISLMultiUnionPWAff.build(ISLNative.isl_multi_union_pw_aff_align_params(getNativePtr(this), getNativePtr(model)));
			} finally {
				taken(this);
				taken(model);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_drop_dims 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMultiUnionPWAff dropDims(ISLDimType type, int first, int n) {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_drop_dims) DISABLED START ***/
		ISLMultiUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMultiUnionPWAff.build(ISLNative.isl_multi_union_pw_aff_drop_dims(getNativePtr(this), type.getValue(), first, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_neg 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMultiUnionPWAff neg() {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_neg) DISABLED START ***/
		ISLMultiUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMultiUnionPWAff.build(ISLNative.isl_multi_union_pw_aff_neg(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_floor 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMultiUnionPWAff floor() {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_floor) DISABLED START ***/
		ISLMultiUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMultiUnionPWAff.build(ISLNative.isl_multi_union_pw_aff_floor(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_intersect_domain 
	 * 
	 * @take this uset
	 * @generated
	**/
	public ISLMultiUnionPWAff intersectDomain(ISLUnionSet uset) {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_intersect_domain) DISABLED START ***/
		ISLMultiUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, uset);
			try {
				res = ISLMultiUnionPWAff.build(ISLNative.isl_multi_union_pw_aff_intersect_domain(getNativePtr(this), getNativePtr(uset)));
			} finally {
				taken(this);
				taken(uset);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_intersect_params 
	 * 
	 * @take this params
	 * @generated
	**/
	public ISLMultiUnionPWAff intersectParams(ISLSet params) {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_intersect_params) DISABLED START ***/
		ISLMultiUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, params);
			try {
				res = ISLMultiUnionPWAff.build(ISLNative.isl_multi_union_pw_aff_intersect_params(getNativePtr(this), getNativePtr(params)));
			} finally {
				taken(this);
				taken(params);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_intersect_range 
	 * 
	 * @take this set
	 * @generated
	**/
	public ISLMultiUnionPWAff intersectRange(ISLSet set) {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_intersect_range) DISABLED START ***/
		ISLMultiUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, set);
			try {
				res = ISLMultiUnionPWAff.build(ISLNative.isl_multi_union_pw_aff_intersect_range(getNativePtr(this), getNativePtr(set)));
			} finally {
				taken(this);
				taken(set);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_apply_aff 
	 * 
	 * @take this aff
	 * @generated
	**/
	public ISLUnionPWAff apply(ISLAff aff) {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_apply_aff) DISABLED START ***/
		ISLUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, aff);
			try {
				res = ISLUnionPWAff.build(ISLNative.isl_multi_union_pw_aff_apply_aff(getNativePtr(this), getNativePtr(aff)));
			} finally {
				taken(this);
				taken(aff);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_apply_pw_aff 
	 * 
	 * @take this pa
	 * @generated
	**/
	public ISLUnionPWAff apply(ISLPWAff pa) {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_apply_pw_aff) DISABLED START ***/
		ISLUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, pa);
			try {
				res = ISLUnionPWAff.build(ISLNative.isl_multi_union_pw_aff_apply_pw_aff(getNativePtr(this), getNativePtr(pa)));
			} finally {
				taken(this);
				taken(pa);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_apply_multi_aff 
	 * 
	 * @take this ma
	 * @generated
	**/
	public ISLMultiUnionPWAff apply(ISLMultiAff ma) {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_apply_multi_aff) DISABLED START ***/
		ISLMultiUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, ma);
			try {
				res = ISLMultiUnionPWAff.build(ISLNative.isl_multi_union_pw_aff_apply_multi_aff(getNativePtr(this), getNativePtr(ma)));
			} finally {
				taken(this);
				taken(ma);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_apply_pw_multi_aff 
	 * 
	 * @take this pma
	 * @generated
	**/
	public ISLMultiUnionPWAff apply(ISLPWMultiAff pma) {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_apply_pw_multi_aff) DISABLED START ***/
		ISLMultiUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, pma);
			try {
				res = ISLMultiUnionPWAff.build(ISLNative.isl_multi_union_pw_aff_apply_pw_multi_aff(getNativePtr(this), getNativePtr(pma)));
			} finally {
				taken(this);
				taken(pma);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_pullback_union_pw_multi_aff 
	 * 
	 * @take this upma
	 * @generated
	**/
	public ISLMultiUnionPWAff pullback(ISLUnionPWMultiAff upma) {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_pullback_union_pw_multi_aff) DISABLED START ***/
		ISLMultiUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, upma);
			try {
				res = ISLMultiUnionPWAff.build(ISLNative.isl_multi_union_pw_aff_pullback_union_pw_multi_aff(getNativePtr(this), getNativePtr(upma)));
			} finally {
				taken(this);
				taken(upma);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_range_product 
	 * 
	 * @take this mupa2
	 * @generated
	**/
	public ISLMultiUnionPWAff rangeProduct(ISLMultiUnionPWAff mupa2) {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_range_product) DISABLED START ***/
		ISLMultiUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, mupa2);
			try {
				res = ISLMultiUnionPWAff.build(ISLNative.isl_multi_union_pw_aff_range_product(getNativePtr(this), getNativePtr(mupa2)));
			} finally {
				taken(this);
				taken(mupa2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_flat_range_product 
	 * 
	 * @take this mupa2
	 * @generated
	**/
	public ISLMultiUnionPWAff flatRangeProduct(ISLMultiUnionPWAff mupa2) {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_flat_range_product) DISABLED START ***/
		ISLMultiUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, mupa2);
			try {
				res = ISLMultiUnionPWAff.build(ISLNative.isl_multi_union_pw_aff_flat_range_product(getNativePtr(this), getNativePtr(mupa2)));
			} finally {
				taken(this);
				taken(mupa2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_factor_range 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMultiUnionPWAff factorRange() {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_factor_range) DISABLED START ***/
		ISLMultiUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMultiUnionPWAff.build(ISLNative.isl_multi_union_pw_aff_factor_range(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_range_factor_domain 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMultiUnionPWAff rangeFactorDomain() {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_range_factor_domain) DISABLED START ***/
		ISLMultiUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMultiUnionPWAff.build(ISLNative.isl_multi_union_pw_aff_range_factor_domain(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_range_factor_range 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMultiUnionPWAff rangeFactorRange() {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_range_factor_range) DISABLED START ***/
		ISLMultiUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMultiUnionPWAff.build(ISLNative.isl_multi_union_pw_aff_range_factor_range(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_range_splice 
	 * 
	 * @take this mupa2
	 * @generated
	**/
	public ISLMultiUnionPWAff rangeSplice(int pos, ISLMultiUnionPWAff mupa2) {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_range_splice) DISABLED START ***/
		ISLMultiUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, mupa2);
			try {
				res = ISLMultiUnionPWAff.build(ISLNative.isl_multi_union_pw_aff_range_splice(getNativePtr(this), pos, getNativePtr(mupa2)));
			} finally {
				taken(this);
				taken(mupa2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_gist_params 
	 * 
	 * @take this context
	 * @generated
	**/
	public ISLMultiUnionPWAff gistParams(ISLSet context) {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_gist_params) DISABLED START ***/
		ISLMultiUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, context);
			try {
				res = ISLMultiUnionPWAff.build(ISLNative.isl_multi_union_pw_aff_gist_params(getNativePtr(this), getNativePtr(context)));
			} finally {
				taken(this);
				taken(context);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_gist 
	 * 
	 * @take this context
	 * @generated
	**/
	public ISLMultiUnionPWAff gist(ISLUnionSet context) {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_gist) DISABLED START ***/
		ISLMultiUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, context);
			try {
				res = ISLMultiUnionPWAff.build(ISLNative.isl_multi_union_pw_aff_gist(getNativePtr(this), getNativePtr(context)));
			} finally {
				taken(this);
				taken(context);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_add 
	 * 
	 * @take this mupa2
	 * @generated
	**/
	public ISLMultiUnionPWAff add(ISLMultiUnionPWAff mupa2) {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_add) DISABLED START ***/
		ISLMultiUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, mupa2);
			try {
				res = ISLMultiUnionPWAff.build(ISLNative.isl_multi_union_pw_aff_add(getNativePtr(this), getNativePtr(mupa2)));
			} finally {
				taken(this);
				taken(mupa2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_sub 
	 * 
	 * @take this mupa2
	 * @generated
	**/
	public ISLMultiUnionPWAff sub(ISLMultiUnionPWAff mupa2) {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_sub) DISABLED START ***/
		ISLMultiUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, mupa2);
			try {
				res = ISLMultiUnionPWAff.build(ISLNative.isl_multi_union_pw_aff_sub(getNativePtr(this), getNativePtr(mupa2)));
			} finally {
				taken(this);
				taken(mupa2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_union_add 
	 * 
	 * @take this mupa2
	 * @generated
	**/
	public ISLMultiUnionPWAff unionAdd(ISLMultiUnionPWAff mupa2) {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_union_add) DISABLED START ***/
		ISLMultiUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, mupa2);
			try {
				res = ISLMultiUnionPWAff.build(ISLNative.isl_multi_union_pw_aff_union_add(getNativePtr(this), getNativePtr(mupa2)));
			} finally {
				taken(this);
				taken(mupa2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_scale_val 
	 * 
	 * @take this v
	 * @generated
	**/
	public ISLMultiUnionPWAff scale(ISLVal v) {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_scale_val) DISABLED START ***/
		ISLMultiUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, v);
			try {
				res = ISLMultiUnionPWAff.build(ISLNative.isl_multi_union_pw_aff_scale_val(getNativePtr(this), getNativePtr(v)));
			} finally {
				taken(this);
				taken(v);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_scale_down_val 
	 * 
	 * @take this v
	 * @generated
	**/
	public ISLMultiUnionPWAff scaleDown(ISLVal v) {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_scale_down_val) DISABLED START ***/
		ISLMultiUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, v);
			try {
				res = ISLMultiUnionPWAff.build(ISLNative.isl_multi_union_pw_aff_scale_down_val(getNativePtr(this), getNativePtr(v)));
			} finally {
				taken(this);
				taken(v);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_mod_multi_val 
	 * 
	 * @take this mv
	 * @generated
	**/
	public ISLMultiUnionPWAff mod(ISLMultiVal mv) {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_mod_multi_val) DISABLED START ***/
		ISLMultiUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, mv);
			try {
				res = ISLMultiUnionPWAff.build(ISLNative.isl_multi_union_pw_aff_mod_multi_val(getNativePtr(this), getNativePtr(mv)));
			} finally {
				taken(this);
				taken(mv);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_scale_multi_val 
	 * 
	 * @take this mv
	 * @generated
	**/
	public ISLMultiUnionPWAff scale(ISLMultiVal mv) {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_scale_multi_val) DISABLED START ***/
		ISLMultiUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, mv);
			try {
				res = ISLMultiUnionPWAff.build(ISLNative.isl_multi_union_pw_aff_scale_multi_val(getNativePtr(this), getNativePtr(mv)));
			} finally {
				taken(this);
				taken(mv);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_scale_down_multi_val 
	 * 
	 * @take this mv
	 * @generated
	**/
	public ISLMultiUnionPWAff scaleDown(ISLMultiVal mv) {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_scale_down_multi_val) DISABLED START ***/
		ISLMultiUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this, mv);
			try {
				res = ISLMultiUnionPWAff.build(ISLNative.isl_multi_union_pw_aff_scale_down_multi_val(getNativePtr(this), getNativePtr(mv)));
			} finally {
				taken(this);
				taken(mv);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLMultiUnionPWAff_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
